#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "svga24.h"

#define MX 1024
#define MY 768

void bod(int x, int y, int col) {
  pixsvga(x, y, col, col, col);
  pixsvga(x+1, y, col, col, col);
}


void gonips(float fx, float fy, float sx, float sy, float ax, float ay, int centx, int centy, int col, long iter) {
  long i = 0;
  float x = 0, y = 0, xx = 0, yy = 0, q;
  for(i = 0; i < iter; i++) {
	x = sin(i*fx+y*y*sx)*ax;
	y = cos(i*fy+x*x*sy)*ay;
//	delay(1);
	q = sqrt((x-xx)*(x-xx) + (y-yy)*(y-yy));
	if (q <= 1) bod(x + centx + 2, y + centy + 2, 255-255*q);
	else bod(x + centx + 2, y + centy + 2, 0);
	xx = x;
	yy = y;
	if (kbhit()) break;
  }
}

void clearsvga(void) {
  int x, y;
  for (x = 0; x < MX; x ++) {
    for (y = 0; y < MY; y++) {
      pixsvga(x, y, 0, 0, 0);
    }
  }
}

void main(void) {
  modsvga(0x118);

  randomize();
  char c = 0;
  float fx, fy, sx, sy, ax, ay;
  while (c != 27) {
	fx = 0.0001*(float)random(10);
	fy = 0.0001*(float)random(10);
	sx = 0.000001*(float)random(30);
	sy = 0.000001*(float)random(30);
	ax = (MX - 4)/2;
	ay = (MY - 4)/2;
	clearsvga();
	gonips(fx, fy, sx, sy, ax, ay, ax, ay, 255, 100000);
	c = getch();
  }
  modvga(0x3);
}